/*
 * Copyright (c) 2007, Going Dot Com Inc. All rights reserved.
 */

package jp.co.going.xbrl.sample.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import jp.co.going.xbrl.common.XbException;
import jp.co.going.xbrl.sample.dao.obj.XbMeasureObj;

/**
 * @author Masako Okayasu
 */
public class XbMeasureDao {

	// singleton作成
    private static XbMeasureDao measure = null;
    // Connection変数
    private static Connection conn = null;
	// ステートメントを作成
    private PreparedStatement stmt;

    // コンストラクタ
    public XbMeasureDao(){
    }

    // インスタンス取得
    public static synchronized XbMeasureDao getInstance(Connection connection){
    	//  インスタンスを生成
    	if(measure == null) {
    		conn = connection;
    		measure = new XbMeasureDao();
    	}

    	return measure;
    }

	public void insert(XbMeasureObj obj) throws XbException{

		try {
			StringBuffer strb_sql = new StringBuffer();
		    // 問合せの実行
	    	strb_sql.append("insert into ");
	    	strb_sql.append("xb_measure ");
	    	strb_sql.append("values ");
	    	strb_sql.append("(?,?,?,?,?)");

			// SQL設定
			stmt = conn.prepareStatement(strb_sql.toString());

			int index = 1;
			stmt.setLong(index++, obj.getMeasure_id());
			stmt.setString(index++, obj.getMeasure_name());
			stmt.setBoolean(index++, obj.isMoney_flag());
			stmt.setString(index++, obj.getValue());
	        stmt.setTimestamp(index++, new java.sql.Timestamp(obj.getCreation_date().getTime()));

		   	// SQL　実行
		   	stmt.executeUpdate();

		    // ステートメントをクローズ
		    stmt.close(); 

		} catch (SQLException e) {
	        throw new XbException(e, "SQL設定エラー: SQLError : " + e.getMessage());
	    }
	}

	public ArrayList<XbMeasureObj> selectAll() throws XbException{

		try {
			StringBuffer  strb_sql = new StringBuffer();
		    // 問合せの実行
			strb_sql.append("select ");
			strb_sql.append("measure_id, ");
			strb_sql.append("measure_name, ");
			strb_sql.append("money_flag, ");
			strb_sql.append("value, ");
			strb_sql.append("creation_date ");
			strb_sql.append("from xb_measure ");
			strb_sql.append("order by measure_id ");

			// SQL設定
			stmt = conn.prepareStatement(strb_sql.toString());

			ResultSet rs = stmt.executeQuery();
			ArrayList<XbMeasureObj> relist = new ArrayList<XbMeasureObj>();
			while(rs.next()) {
				XbMeasureObj obj = new XbMeasureObj();
				obj.setMeasure_id(rs.getLong("measure_id"));
				obj.setMeasure_name(rs.getString("measure_name"));
				obj.setMoney_flag(rs.getBoolean("money_flag"));
				obj.setValue(rs.getString("value"));
				obj.setCreation_date(rs.getDate("creation_date"));
				relist.add(obj);
			}

		    // 結果セットをクローズ
		    rs.close();

		    // ステートメントをクローズ
		    stmt.close();

		    return relist;
		} catch (SQLException e) {
	        throw new XbException(e, "SQL設定エラー: SQLError : " + e.getMessage());
	    }
	}

	public XbMeasureObj select(long measure_id) throws XbException{

		try {
			StringBuffer  strb_sql = new StringBuffer();
		    // 問合せの実行
			strb_sql.append("select ");
			strb_sql.append("measure_id, ");
			strb_sql.append("measure_name, ");
			strb_sql.append("money_flag, ");
			strb_sql.append("value, ");
			strb_sql.append("creation_date ");
			strb_sql.append("from xb_measure ");
			strb_sql.append("where measure_id=? ");

			// SQL設定
			stmt = conn.prepareStatement(strb_sql.toString());

			int index = 1;
			stmt.setLong(index++, measure_id);

			ResultSet rs = stmt.executeQuery();
			XbMeasureObj obj = null;
			while(rs.next()) {
				obj = new XbMeasureObj();
				obj.setMeasure_id(rs.getLong("measure_id"));
				obj.setMeasure_name(rs.getString("measure_name"));
				obj.setMoney_flag(rs.getBoolean("money_flag"));
				obj.setValue(rs.getString("value"));
				obj.setCreation_date(rs.getDate("creation_date"));
			}

		    // 結果セットをクローズ
		    rs.close();

		    // ステートメントをクローズ
		    stmt.close();

		    return obj;
		} catch (SQLException e) {
	        throw new XbException(e, "SQL設定エラー: SQLError : " + e.getMessage());
	    }
	}

	public long getNextId() throws XbException{

		try {
			StringBuffer  strb_sql = new StringBuffer();
		    // 問合せの実行
			strb_sql.append("select ");
			strb_sql.append("max(measure_id)+1 as max ");
			strb_sql.append("from xb_measure ");

			// SQL設定
			stmt = conn.prepareStatement(strb_sql.toString());

			ResultSet rs = stmt.executeQuery();
			rs.next();

			return (rs.getLong("max")==0 ? 1 : rs.getLong("max"));
		} catch (SQLException e) {
	        throw new XbException(e, "SQL設定エラー: SQLError : " + e.getMessage());
	    }
	}
}